      PROGRAM CATRA

c  program that cuts CA coordinates from all atom trajectories

C  COMMAND LINE PARAMETERS:
C  1) GROMOS COORDINATE FILE
C  2) GROMOS COORDINATE FILE CONTAINING ONLY CA
C  3) XTC TRAJECTORY FILE
C  4) XTC TRAJECTORY FILE CONTAINING ONLY CA

      IMPLICIT NONE

      include 'params.f'

      INTEGER NCA,I,T,NAT,RESNR(maxat),ATNR(maxat),NRFRMS,
     &        M,IDR,IDW,RET,NATX,STEP
      CHARACTER*5 ATNM(maxat),RESNM(maxat)

      CHARACTER*80 TITLE,COORNAM,RNAM,WNAM

      REAL*4 X(maxat*3),XCA(maxat*3),BOX(9),TIME,PREC    


      CALL GETARG(1,COORNAM)
      OPEN (10,FILE=COORNAM,STATUS='OLD')
      CALL GETARG(2,COORNAM)
      OPEN (11,FILE=COORNAM,STATUS='UNKNOWN')
      CALL GETARG(3,RNAM)
      CALL GETARG(4,WNAM)
      READ(10,104) TITLE
      WRITE(11,104) TITLE
      READ(10,101) NAT
      NCA=0
      DO I=1,NAT
         READ(10,101,END=20,ERR=21) RESNR(I),RESNM(I),ATNM(I),
     &        ATNR(I),X(3*I-2),X(3*I-1),X(3*I)
         IF (ATNM(I).EQ.'   CA') NCA=NCA+1
      ENDDO
      GOTO 22
 20   WRITE(0,*) 'PREMATURE END OF FILE READING COORDINATE FILE'
      WRITE(0,*) 'LINE: ',I
      STOP
 21   WRITE(0,*) 'ERROR READING COORDINATE FILE'
      WRITE(0,*) 'LINE: ',I
      STOP
 22   CONTINUE
      REWIND(10)
      READ(10,104) TITLE
      READ(10,101) NAT
      WRITE(11,101) NCA
      DO I=1,NAT
         READ(10,101,END=30,ERR=31) RESNR(I),RESNM(I),ATNM(I),
     &        ATNR(I),X(3*I-2),X(3*I-1),X(3*I)
         IF (ATNM(I).EQ.'   CA') WRITE(11,101) RESNR(I),
     &        RESNM(I),ATNM(I),ATNR(I),X(3*I-2),X(3*I-1),X(3*I)
      ENDDO
      GOTO 32
 30   WRITE(0,*) 'PREMATURE END OF FILE READING COORDINATE FILE'
      WRITE(0,*) 'LINE: ',I
      STOP
 31   WRITE(0,*) 'ERROR READING COORDINATE FILE'
      WRITE(0,*) 'LINE: ',I
      STOP
 32   CONTINUE      
      CLOSE(10)
      CLOSE(11)

      CALL XTCOPEN(IDR,RNAM,"R",maxat)

      CALL XDRFOPEN(IDW,WNAM,"W",RET)
      IF (RET.EQ.0) THEN
         WRITE(0,*) 'ERROR OPENING ',WNAM
         STOP
      ENDIF

      NRFRMS=1E6
      DO T=1,NRFRMS
         CALL READXTC(IDR,NATX,STEP,TIME,BOX,X,PREC,RET)
         IF (RET.EQ.0.AND.T.EQ.1) THEN
            WRITE(0,*) 'ERROR READING XTC FROM ',RNAM
            STOP
         ELSE IF(RET.EQ.0) THEN
            GOTO 50
         ENDIF
         IF (NATX.NE.NAT) THEN
            WRITE(0,*) 'NR OF ATOMS IN:'
            WRITE(0,*) COORNAM
            WRITE(0,*) 'DOES NOT MATCH NR OF ATOMS IN STDIN'
            STOP
         ENDIF
         NCA=0
         DO I=1,NAT
            IF (ATNM(I) .EQ. '   CA') THEN
               NCA=NCA+1
               DO M=2,0,-1
                  XCA(NCA*3-M)=X(3*I-M)
               ENDDO
            ENDIF
         ENDDO
         CALL WRITEXTC(IDW,NCA,STEP,TIME,BOX,XCA,PREC,RET)
      ENDDO

 50   CONTINUE

 101  FORMAT(I5,2A5,I5,3F8.3)
 104  FORMAT(A80)
 105  FORMAT(I5)
     
      END




