      subroutine getring(resnam,atnam,isring,isqring,nr,libdir)
c23456789012345678901234567890123456789012345678901234567890123456789012
C----
C---- isring(i) becomes true if atom i is part of ring system
C----
      implicit none
      character*80 sdum
      character*(*) libdir
      integer i,j,nrring,maxring,nr,nrrealring
      parameter(maxring=200)
      logical isring(*),isqring(*)
      character*5 ringres(maxring),ringat(maxring),resnam(*),atnam(*)

      call bbopen(1,libdir,'RING.DAT','OLD')

      do i=1,nr
         isring(i)=.false.
         isqring(i)=.false.
      enddo

      nrring=0
      nrrealring=0
 5    continue
      read(1,100,err=10,end=20) sdum
      if (sdum(1:1).eq.'#'.or.sdum(1:3).eq.'   '.or.sdum(1:2).eq.'!R') 
     &     goto 5
      if (sdum(1:2).eq.'!Q') then
         nrrealring=nrring
         goto 5
      endif
      nrring=nrring+1
      if (nrring.gt.maxring) then
         write(0,*) 'Error: Nr of ring atoms in database too',
     &        ' large for array bounds'
         stop
      endif
      read(sdum,120,err=10,end=20) ringres(nrring),ringat(nrring)
      goto 5
 10   write(0,*) 'Error reading ring database'
      stop
 20   if (nrring.eq.0) then
         write(0,*) 'Unexpected EOF while reading ring database'
         stop
      endif
      close(1)

      do i=1,nr
         do j=1,nrrealring
            if(atnam(i).eq.ringat(j).and.resnam(i).eq.
     &           ringres(j)) isring(i)=.true.
         enddo
         do j=nrrealring+1,nrring
            if(atnam(i).eq.ringat(j).and.resnam(i).eq.
     &           ringres(j)) then
               isqring(i)=.true.
            endif
         enddo
      enddo

      

 100  format(a80)
 120  format(2a5)

      return

      end
      subroutine getdonacc(donacc,atnam,resnam,nat,libdir,hbdis)
C----
C---- determines for each atom whether it can be a hydrogen bond
C---- donor or acceptor
C----
      implicit none
      integer i,j,nat,doncnt,acccnt,maxda,donacc(*)
      parameter (maxda=50)
      logical accflg,donflg,disflg
      character*5 atnam(*),resnam(*),drn(maxda),dan(maxda),
     &            arn(maxda),aan(maxda),dum
      real hbdis
      character*3 rdum
      character*80 libdir,sdum
C----
C---- first read database of donors and acceptors
C----
      donflg=.false.
      accflg=.false.
      disflg=.false.
      doncnt=0
      acccnt=0
      call bbopen(1,libdir,'HBONDS.DAT','OLD')
 10   read(1,100,end=20,err=20) sdum
      if (sdum(1:3).eq.'Don') donflg=.true.
      if (sdum(1:3).eq.'Acc') accflg=.true.
      if (sdum(1:3).eq.'Dis') disflg=.true.
      if (sdum(1:3).ne.'Don'.and.sdum(1:3).ne.'Acc'.and.
     &    sdum(1:3).ne.'   '.and.sdum(1:3).ne.'Min'.and.
     &    sdum(1:1).ne.'#') then
         if (donflg) then
            doncnt=doncnt+1
            if (doncnt.gt.maxda) then
               write(0,*) 'Error: Nr of H-bond donors in database too',
     &                    ' large for array bounds'
               stop
            endif
            read(sdum,110,end=20,err=20) drn(doncnt),dan(doncnt)
            call gvsshr(dan(doncnt),5)
         else if (accflg) then
            acccnt=acccnt+1
            if (acccnt.gt.maxda) then
               write(0,*) 'Error: Nr of H-bond acceptors in database ',
     &                    'too large for array bounds'
               stop
            endif
            read(sdum,110,end=20,err=20) arn(acccnt),aan(acccnt)
            call gvsshr(aan(acccnt),5)
         else if (disflg) then
            read(sdum,*,end=20,err=20) hbdis
            hbdis=hbdis/10.0
         endif
      else if (sdum(1:3).eq.'Don') then
         donflg=.true.
         accflg=.false.
         disflg=.false.
      else if (sdum(1:3).eq.'Acc') then
         accflg=.true.
         donflg=.false.
         disflg=.false.
      else if (sdum(1:3).eq.'Min') then
         accflg=.false.
         donflg=.false.
         disflg=.true.  
      endif
      goto 10
 20   close(1)
C----
C---- now assign donors and acceptors
C----
      do i=1,nat
         donacc(i)=0
         dum=resnam(i)
         call gvstcp(dum)
         rdum=dum(1:3)
         do j=1,doncnt
            if (drn(j)(1:3).eq.'*  '.or.drn(j)(1:3).eq.rdum) then
               if (dan(j).eq.atnam(i)) donacc(i)=1
            endif
         enddo
         do j=1,acccnt
            if (arn(j)(1:3).eq.'*  '.or.arn(j)(1:3).eq.rdum) then
               if (aan(j).eq.atnam(i)) then
                  if (donacc(i).eq.1) then 
                     donacc(i)=3
                  else
                     donacc(i)=2
                  endif
               endif
            endif
         enddo
      enddo

 100  format(a80)
 110  format(2a5)

      return

      end
      subroutine getcharge(resnam,atnam,nat,charge,libdir,term,chdis)
C----
C---- determines atomic charges (only those that can
C---- be involved in salt bridges)
C----
      implicit none
      integer maxcharge
      parameter (maxcharge=100)
      integer i,j,nat,ncharge,term(*)
      character*80 sdum,sdum2
      character*(*) libdir
      character*5 resnam(*),atnam(*),dr(maxcharge),
     &            da(maxcharge),rdum
      real charge(*),dc(maxcharge),chdis

      call bbopen(1,libdir,'CHARGE.DAT','OLD')

      do i=1,nat
         charge(i)=0.0
      enddo

      ncharge=0
      do i=1,1000
         read (1,100,err=10,end=20) sdum
         if (sdum(1:1).ne.'#'.and.sdum(1:3).ne.'Dis'.and.
     &    sdum(1:3).ne.'   ') then
            ncharge=ncharge+1
            if (ncharge.gt.maxcharge) then
               write(0,*) 'Error: Nr of charged atoms in database too',
     &                    ' large for array bounds'
               stop
            endif
            read (sdum,120,err=10,end=20) dr(ncharge),da(ncharge),
     &           dc(ncharge)
         else if (sdum(1:3).eq.'Dis') then
            sdum2=sdum(10:80)
            read(sdum2,*,err=10,end=20) chdis
         endif
      enddo
      goto 30
 10   write(0,*) 'Error reading charge database'
      stop
 20   if (ncharge.eq.0) then
         write(0,*) 'Unexpected EOF while reading charge database'
         stop
      endif
 30   continue
      close(1)
#     if defined (DEBUG)
         write(0,*) 'Nr of read charged atoms:',ncharge
#     endif
      do i=1,nat
         rdum='xxxxx'
         if (term(i).eq.-1) rdum='NTERM'
         if (term(i).eq.1) rdum='CTERM'
         do j=1,ncharge
            if ((atnam(i).eq.da(j).and.rdum.eq.dr(j)).or.
     &           (atnam(i).eq.da(j).and.resnam(i).eq.dr(j)))
     &         charge(i)=dc(j)
         enddo
      enddo

 100  format(a80)
 120  format(2a5,f5.1)

      return

      end
      subroutine getpol(pol,acc,resnam,nat,libdir)
C----
C---- determines which are the polar AA's
C----
      implicit none
      integer maxaa
      parameter (maxaa=100)
      integer i,j,nat,naa
      character*80 sdum
      character*(*) libdir
      character*5 resnam(*)
      character*3 dr(maxaa)
      real acc(*),dacc(maxaa)
      character*1 pol(*),dpol(maxaa)

      call bbopen(1,libdir,'AA.DAT','OLD')


      naa=0
 5    read (1,100,err=10,end=20) sdum
      if (sdum(1:1).ne.'#'.and.sdum(1:3).ne.'   ') then
         naa=naa+1
         if (naa.gt.maxaa) then
            write(0,*) 'Error: Nr of amino acids in database too',
     &           ' large for array bounds'
            stop
         endif
         read (sdum,120,err=10,end=20) dr(naa),dpol(naa),dacc(naa)
      endif
      goto 5
 10   write(0,*) 'Error reading charge database'
      stop
 20   if (naa.eq.0) then
         write(0,*) 'Unexpected EOF while reading charge database'
         stop
      endif
 30   continue
      close(1)
#     if defined (DEBUG)
         write(0,*) 'Nr of read amino acids:',naa
#     endif
      do i=1,nat
         pol(i)='x'
         do j=1,naa
            if (resnam(i)(1:3).eq.dr(j)) then
               pol(i)=dpol(j)               
               acc(i)=acc(i)/dacc(j)
            endif
         enddo
      enddo

 100  format(a80)
 120  format(a3,1x,a1,f5.0)

      return

      end

      subroutine getvdwrad(typnam,atrad,nat,libdir)
C----
C---- returns van der waals radii on the basis of atomtypes
C----
      implicit none
      integer maxvdw
      parameter(maxvdw=100)
      character*5 typnam(*),names(maxvdw)
      character*80 libdir,sdum
      integer nvdw,i,j,nat
      real atrad(2,*),radii(maxvdw),bondp(maxvdw)
      logical present

      call bbopen(1,libdir,'ATOMS.DAT','OLD')

      nvdw=0
 5    continue
      read(1,110,err=10,end=20) sdum
      if (sdum(1:3).eq.'com') goto 20
      if (sdum(1:1).ne.'#'.and.sdum(1:5).ne.'     '.and.
     &     sdum(1:3).ne.'typ' ) then
         nvdw=nvdw+1
         if (nvdw.gt.maxvdw) then
            write(0,*) 'Error: Nr of VDW radii in database too',
     &           ' large for array bounds'
            stop
         endif
         read(sdum,100,err=10,end=20) names(nvdw),radii(nvdw),
     &        bondp(nvdw)
      endif
      goto 5
 10   write(0,*) 'Error while reading ATOMS.DAT'
      write(0,*) 'subroutine getvdwrad'
      write(0,*) 'Nr of read types =',nvdw
      stop
 20   if (nvdw.eq.0) then
         write(0,*) 'Unexpected EOF while reading ATOMS.DAT'
         stop
      endif
      close(1)
#     if defined (DEBUG)
         write(0,*) 'Nr of read VDW radii, bond params:',nvdw
#     endif
      do i=1,nat
         present=.false.
         atrad(1,i)=0.0
         atrad(2,i)=0.0
         do j=1,nvdw
            if (typnam(i).eq.names(j)) then
               present=.true.
               atrad(1,i)=radii(j)
               atrad(2,i)=bondp(j)
            endif
         enddo
         if (.not.present) then
            write(0,220) typnam(i),'ATOMS.DAT'
            stop
         endif
         if (abs(atrad(1,i)).lt.0.001) then
            write(0,200) typnam(i)
         endif
         if (abs(atrad(2,i)).lt.0.001) then
            write(0,210) typnam(i)
         endif
      enddo

 100  format(a5,2f6.2)
 110  format(a80)
 200  format('WARNING - zero VDW radius for atomtype: ',a5)
 210  format('WARNING - zero bond param for atomtype: ',a5)
 220  format('ERROR - atomtype ',A5,' not found in ',a)

      return

      end
      subroutine getatomtypes(atnam,resnam,type,nat,libdir,hflg)
C----
C---- returns atom type for each atom depending on atom and residue name
C----
      implicit none
      integer i,j,nat,maxtypes,ntypes
      parameter (maxtypes=300)
      character*80 libdir,sdum
      character*5 atnam(*),resnam(*),type(*),anam(maxtypes),
     &     rnam(maxtypes),tnam(maxtypes),rdum,adum,xdum
      logical present,hflg
      
c      if (hflg) then
c         call bbopen(1,libdir,'RESIDUES_H.DAT','OLD')
c      else
         call bbopen(1,libdir,'RESIDUES.DAT','OLD')
c      endif

      ntypes=0
 5    continue
      read (1,100,err=10,end=20) sdum
      if (sdum(1:1).ne.'#'.and.sdum(1:3).ne.'   ') then
         ntypes=ntypes+1
         if (ntypes.gt.maxtypes) then
            write(0,*) 'Error: Nr of atom types in database too',
     &           ' large for array bounds'
            stop
         endif
         read (sdum,120,err=10,end=20) rnam(ntypes),anam(ntypes),
     &        tnam(ntypes)
      endif
      goto 5
 10   write(0,*) 'Error reading residue database'
      stop
 20   if (ntypes.le.1) then
         write(0,*) 'Unexpected EOF while reading residue database'
         stop
      endif
      close(1)
#     if defined (DEBUG)
         write(0,*) 'Nr of read atom types:',ntypes
#     endif

      do i=1,nat
         present=.false.
C-------
C------- first check if it is a specific type
C-------
         do j=1,ntypes
            if (resnam(i)(1:3).eq.rnam(j)(1:3).and.
     &           atnam(i).eq.anam(j)) then
               present=.true.
               type(i)=tnam(j)
            endif
         enddo
C-------
C------- now for general types
C-------
         if (.not.present) then
            rdum='GEN  '
            do j=1,ntypes
               if (rdum(1:3).eq.rnam(j)(1:3).and.
     &              atnam(i).eq.anam(j)) then
                  present=.true.
                  type(i)=tnam(j)
               endif
            enddo
         endif
C-------
C------- make it a default type
C-------
         if (.not.present) then
            write(0,200) atnam(i),resnam(i)
            rdum='OTH  '
            xdum=atnam(i)
            call gvsshl(xdum)
            adum(1:3)='   '
            adum(4:4)=xdum(1:1)
            adum(5:5)='*'
            write(0,205) adum
            present=.false.
            do j=1,ntypes
               if (rdum.eq.rnam(j).and.adum.eq.anam(j)) then
                  present=.true.
                  type(i)=tnam(j)
               endif
            enddo
            if (.not.present) then
               write(0,210) adum,rdum
               stop
            endif
         endif
      enddo

 100  format(a80)
 120  format(3a5,1x,i1)
 200  format('warning: unknown atom type ',A5,' in residue ',A5)
 205  format('changing to default type ',A5)
 210  format('error: no default atom type ',A5,' in residue ',A5) 

      return

      end
      
      subroutine getmargins (sigma,dim,libdir,damp)
C----
C---- read distance margins for different categories from database
C----
C---- mode 1: bonds
C----      2: angles
C----      3: ring
C----      4: omega
C----      5: phi/psi
C----      6: side chain 1-4
C----      7: secondary structure
C----      8: non-bonded pairs
C----      9: alternative nonbondeds
C----     10: all other (defined) pairs

      implicit none
      integer i,j,dim
      character*80 sdum,innam
      character*(*) libdir
      real sigma(dim,dim,2),damp

      innam='MARGINS.DAT'

      call bbopen(1,libdir,innam,'OLD')

      i=0
      j=0
 9    continue
      read (1,100,end=10,err=11) sdum
      if (sdum(1:1).eq.'#'.or.sdum(1:3).eq.'   ') goto 9
      if (sdum(1:1).eq.'!') then
         i=i+1
         j=1
         goto 9
      endif
      read(sdum,*,end=10,err=11) sigma(i,j,1),sigma(i,j,2)
      sigma(i,j,1)=sigma(i,j,1)*damp
      sigma(i,j,2)=sigma(i,j,2)*damp
      j=j+1
      goto 9
 10   continue
      if (i.eq.0.or.j.eq.1) then
         write(0,*) 'Unexpected EOF in ',innam(1:40)
         write(0,*) 'while reading params for group:',i
         write(0,*) 'last line read:'
         write(0,*) sdum
         stop
      endif
      goto 12
 11   write(0,*) 'Error while reading from ',innam(1:40)
      stop
 12   continue
      close(1)

 100  format(a80)
      
      return

      end
      subroutine getvdwcomb(types1,types2,vdwdis,ncomb,maxcomb,libdir)
C----
C---- returns vdw distances for different combinations of
C---- atom types
C----
      implicit none
      integer ncomb,maxcomb
      character*5 types1(*),types2(*)
      real vdwdis(*)
      character*(*) libdir
      character*80 sdum

      logical startread

      call bbopen(1,libdir,'ATOMS.DAT','OLD')

      ncomb=0
      startread=.false.
 5    continue
      read(1,110,err=10,end=20) sdum
      if (sdum(1:3).eq.'com') then
         startread=.true.
         goto 5
      endif
      if ((sdum(1:1).ne.'#'.and.sdum(1:5).ne.'     ').and.
     &     startread) then
         ncomb=ncomb+1
         if (ncomb.gt.maxcomb) then
            write(0,*) 'Error: Nr of VDW radii in database too',
     &           ' large for array bounds'
            stop
         endif
         read(sdum,100,err=10,end=20) types1(ncomb),types2(ncomb),
     &        vdwdis(ncomb)
         vdwdis(ncomb)=vdwdis(ncomb)+0.25
      endif
      goto 5
 10   write(0,*) 'Error while reading ATOMS.DAT'
      write(0,*) 'subroutine getvdwcomb'
      write(0,*) 'last line read was:'
      write(0,*) sdum
      write(0,*) 'Nr of read combinations =',ncomb
      stop
 20   continue
      close(1)
#     if defined (DEBUG)
         write(0,*) 'Nr of read VDW combinations:',ncomb
#     endif      

 100  format(2a5,f5.1)
 110  format(a80)

      return
      end
      subroutine getdis(disnam,in,meansig,lbub,count,x,weight)
C----
C---- reads pairs and determines distance bounds
C----
      implicit none
      include 'params.f'
      integer i,in(2,maxdis),count,count2,n1,n2,linecount,
     &     tag(maxdis),ncon
      real*4 meansig(2,maxdis),lbub(2,maxdis),
     &     sig,len,clen,getlen,x(*),lb,ub,weight(*)
      character*80 disnam,sdum
C----
C---- first read indices
C----
      count=0
      linecount=0
      ncon=0
      
      call bbopenr(1,disnam)

 1    continue
      linecount=linecount+1
      read(1,1000,end=40,err=39) sdum
      if (sdum(1:1).eq.'#'.or.sdum(1:5).eq.'     ') goto 1
      read(sdum,*,end=40,err=39) n1,n2
      if (weight(n1).gt.0..or.weight(n2).gt.0.) then
         count=count+1
         call checkndis(count,maxdis)
         if (n2.gt.n1) call swap(n1,n2)
         in(1,count)=n1
      endif
      goto 1

 39   write (0,*) 'Error while reading from ',disnam(1:40)
      write (0,*) 'on line:',linecount
      stop
 40   continue

      rewind (1)
C----
C---- sort to first index
C----
      write(6,300)
      do i=1,count
         tag(i)=i
      enddo
      call sortrow(in,count,tag,1,2,maxdis)
      do i=1,count
         in(2,tag(i))=i
      enddo
      do i=1,count
         tag(i)=in(2,i)
      enddo
C----
C---- now read the distances and bounds
C----
      count2=0
      linecount=0
      
 41   continue
      linecount=linecount+1
      read(1,1000,end=43,err=42) sdum
      if (sdum(1:1).eq.'#'.or.sdum(1:5).eq.'     ') goto 41
      read(sdum,*,end=43,err=42) n1,n2,len,lb,ub
      if (weight(n1).gt.0..or.weight(n2).gt.0.) then
         count2=count2+1
         len=len/10.0
         lb=lb/10.0
         ub=ub/10.0
         sig=(ub-lb)/5.
         if (n2.gt.n1) call swap(n1,n2)
         clen=getlen(n1,n2,x)
c         if (abs(len-clen).gt.0.001) write (0,200) n1,n2,len,clen
         if (abs(len-clen).gt.0.001) ncon=ncon+1
         in(2,tag(count2))=n2
         meansig(1,tag(count2))=len
         meansig(2,tag(count2))=sig
         lbub(1,tag(count2))=lb
         lbub(2,tag(count2))=ub
      endif
      goto 41

 42   write (0,*) 'Error while reading from ',disnam(1:40)
      write (0,*) 'on line:',linecount
      stop
 43   continue

      close (1)

      if (count2.ne.count) then
         write(0,*) 'Error: nr of lines inconsistent in ',disnam(1:40)
         stop
      endif
      
      if (ncon.gt.0) write(0,250) ncon

 120  format (2i5,4f10.4)
 200  format ('warning: distance conflict:',2i5,2f10.5)
 250  format ('warning: Nr. of distances that do not match input ',
     &     'structure:',i9)
 300  format ('sorting distances...')
 1000 format (a80)

      return

      end
      subroutine sortrow (a,n,itag,row,dim1,dim2)
C----
C---- hacked version of GVSORT, stolen from WHAT IF
C----
      implicit      none
      integer       dim1,dim2
      integer       n,iu(32),il(32),itag(dim2),m,i,j,k,ij,jtg,l,row
      integer       a(dim1,dim2), t, tt

      tt=0.0
      m=1
      i=1
      j=n
    5 if(i .ge. j) go to 70
   10 k=i
      ij=(j+i)/2
      t=a(row,ij)
      if(a(row,i) .le. t) go to 20
      a(row,ij)=a(row,i)
      a(row,i)=t
      t=a(row,ij)
      jtg=itag(ij)
      itag(ij)=itag(i)
      itag(i)=jtg
   20 l=j
      if(a(row,j) .ge. t) go to 40
      a(row,ij)=a(row,j)
      a(row,j)=t
      t=a(row,ij)
      jtg=itag(ij)
      itag(ij)=itag(j)
      itag(j)=jtg
      if(a(row,i) .le. t) go to 40
      a(row,ij)=a(row,i)
      a(row,i)=t
      t=a(row,ij)
      jtg=itag(ij)
      itag(ij)=itag(i)
      itag(i)=jtg
      go to 40
   30 a(row,l)=a(row,k)
      a(row,k)=tt
      jtg=itag(l)
      itag(l)=itag(k)
      itag(k)=jtg
   40 l=l-1
      if(a(row,l) .gt. t) go to 40
      tt=a(row,l)
   50 k=k+1
      if(a(row,k) .lt. t) go to 50
      if(k .le. l) go to 30
      if(l-i .le. j-k) go to 60
      il(m)=i
      iu(m)=l
      i=k
      m=m+1
      go to 80
   60 il(m)=k
      iu(m)=j
      j=l
      m=m+1
      go to 80
   70 m=m-1
      if(m.eq.0) return
      i=il(m)
      j=iu(m)
80    if(j-i.ge.1) goto 10
      if(i.eq.1) goto 5
      i=i-1
   90 i=i+1
      if(i .eq. j) go to 70
      t=a(row,i+1)
      if(a(row,i) .le. t) go to 90
      jtg=itag(i+1)
      k=i
  100 a(row,k+1)=a(row,k)
      itag(k+1)=itag(k)
      k=k-1
      if(t .lt. a(row,k)) go to 100
      a(row,k+1)=t
      itag(k+1)=jtg
      go to 90
      end


      subroutine bbopen(unit,dirnm,filnm,status)

      implicit none

      integer unit,len1,len2,gvflen

      character*(*) dirnm,filnm,status

      character*80 name

      logical gvfisf

      call gvsshl(dirnm)
      len1=gvflen(dirnm)
      call gvsshl(filnm)
      len2=gvflen(filnm)
      if (len1+len2.gt.79) then
         write(0,300)
         write(0,*) 'dirnm=',dirnm(1:len1),'with length ' ,len1
         write(0,*) 'filnm=',filnm(1:len2),'with length ',len2
         stop
      endif
      write(name,110) dirnm(1:len1),'/',filnm(1:len2)
C----
C---- first check current directory, then libdir
C----
      if (gvfisf(filnm)) then
         open(unit,file=filnm,status=status)
      else if (gvfisf(name)) then
         open(unit,file=name,status=status)
      else
         write(0,200) filnm(1:len2)
         write(0,210)
         stop
      endif

 110  format(a,a1,a)
 200  format('ERROR - file not found: ',a)
 210  format('please check CONCOORDLIB environment variable')
 300  format('ERROR - buffer size exceeded in subroutine bbopen')

      return

      end
      subroutine bbopenr(unit,filnm)
C----
C---- opens file in read mode in current directory
C----
      implicit none
      integer unit,len,gvflen
      character*(*) filnm
      logical gvfisf

      call gvsshl(filnm)

      if (gvfisf(filnm)) then
         open(unit,file=filnm,status='OLD')
      else
         len=gvflen(filnm)
         write(0,100) filnm(1:len)
         stop
      endif

 100  format('ERROR - file not found: ',a)

      return

      end
      subroutine bbopenw(unit,filnm)
C----
C---- opens file in write mode in current directory
C----
      implicit none
      integer unit
      character*(*) filnm
      logical gvfisf

      call gvsshl(filnm)
      if (gvfisf(filnm)) call backitup(filnm)
      open(unit,file=filnm,status='UNKNOWN')

      return
      end

      subroutine backitup(filnm)
C----
C---- backs up filnm fo filnm~
C----
      implicit none
      integer len,gvflen
      character*80 syslin
      character*(*) filnm

      len=gvflen(filnm)
    
      write(6,100) filnm(1:len),filnm(1:len)
      if (2*len+5.gt.80) then
         write(0,300)
         stop
      endif
      write(syslin,200) filnm(1:len),filnm(1:len)
      len=gvflen(syslin)
      call system(syslin(1:len))

 100  format('backing up ',a,' to ',a,'~')
 200  format('mv ',a,' ',a,'~')
 300  format('ERROR - buffer size exceeded in subroutine backitup')
      
      return
      end

      subroutine checkndis(ndis,maxdis)
      implicit none

      integer ndis,maxdis
      
      if (ndis.gt.maxdis) then
         write(0,*) 'Error -  increase parameter MAXDIS'
         stop
      endif

      return

      end
